Index: serefpolicy-contrib-20140730/hypervkvp.if
===================================================================
--- serefpolicy-contrib-20140730.orig/hypervkvp.if
+++ serefpolicy-contrib-20140730/hypervkvp.if
@@ -1,32 +1,134 @@
-## <summary>HyperV key value pair (KVP).</summary>
+
+## <summary>policy for hypervkvp</summary>
+
+########################################
+## <summary>
+##	Execute TEMPLATE in the hypervkvp domin.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`hypervkvp_domtrans',`
+	gen_require(`
+		type hypervkvp_t, hypervkvp_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, hypervkvp_exec_t, hypervkvp_t)
+')
+
+########################################
+## <summary>
+##	Search hypervkvp lib directories.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`hypervkvp_search_lib',`
+	gen_require(`
+		type hypervkvp_var_lib_t;
+	')
+
+	allow $1 hypervkvp_var_lib_t:dir search_dir_perms;
+	files_search_var_lib($1)
+')
+
+########################################
+## <summary>
+##	Read hypervkvp lib files.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`hypervkvp_read_lib_files',`
+	gen_require(`
+		type hypervkvp_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	allow $1 hypervkvp_var_lib_t:dir list_dir_perms;
+	read_files_pattern($1, hypervkvp_var_lib_t, hypervkvp_var_lib_t)
+')
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an hypervkvp environment.
+##	Create, read, write, and delete
+##	hypervkvp lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <param name="role">
+#
+interface(`hypervkvp_manage_lib_files',`
+	gen_require(`
+		type hypervkvp_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_files_pattern($1, hypervkvp_var_lib_t, hypervkvp_var_lib_t)
+')
+
+#######################################
+## <summary>
+##  Execute hypervkvp server in the hypervkvp domain.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
+## </param>
+#
+interface(`hypervkvp_systemctl',`
+    gen_require(`
+        type hypervkvp_t;
+        type hypervkvp_unit_file_t;
+    ')
+
+    systemd_exec_systemctl($1)
+    allow $1 hypervkvp_unit_file_t:file read_file_perms;
+    allow $1 hypervkvp_unit_file_t:service manage_service_perms;
+
+    ps_process_pattern($1, hypervkvp_t)
+    ')
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an hypervkvp environment
+## </summary>
+## <param name="domain">
 ##	<summary>
-##	Role allowed access.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
-## <rolecap/>
 #
 interface(`hypervkvp_admin',`
 	gen_require(`
-		type hypervkvpd_t, hypervkvpd_initrc_exec_t;
+		type hypervkvp_t;
+		type hypervkvp_unit_file_t;
+	')
+
+	allow $1 hypervkvp_t:process signal_perms;
+	ps_process_pattern($1, hypervkvp_t)
+
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 hypervkvp_t:process ptrace;
 	')
 
-	allow $1 hypervkvpd_t:process { ptrace signal_perms };
-	ps_process_pattern($1, hypervkvpd_t)
+	hypervkvp_manage_lib_files($1)
 
-	init_labeled_script_domtrans($1, hypervkvpd_initrc_exec_t)
-	domain_system_change_exemption($1)
-	role_transition $2 hypervkvpd_initrc_exec_t system_r;
-	allow $2 system_r;
+	hypervkvp_systemctl($1)
+	admin_pattern($1, hypervkvp_unit_file_t)
+	allow $1 hypervkvp_unit_file_t:service all_service_perms;
 ')
Index: serefpolicy-contrib-20140730/hypervkvp.te
===================================================================
--- serefpolicy-contrib-20140730.orig/hypervkvp.te
+++ serefpolicy-contrib-20140730/hypervkvp.te
@@ -5,24 +5,70 @@ policy_module(hypervkvp, 1.0.0)
 # Declarations
 #
 
-type hypervkvpd_t;
-type hypervkvpd_exec_t;
-init_daemon_domain(hypervkvpd_t, hypervkvpd_exec_t)
+attribute hyperv_domain;
 
-type hypervkvpd_initrc_exec_t;
-init_script_file(hypervkvpd_initrc_exec_t)
+type hypervkvp_t, hyperv_domain;
+type hypervkvp_exec_t;
+init_daemon_domain(hypervkvp_t, hypervkvp_exec_t)
+
+type hypervkvp_initrc_exec_t;
+init_script_file(hypervkvp_initrc_exec_t)
+
+type hypervkvp_unit_file_t;
+systemd_unit_file(hypervkvp_unit_file_t)
+
+type hypervkvp_var_lib_t;
+files_type(hypervkvp_var_lib_t)
+
+type hypervvssd_t, hyperv_domain;
+type hypervvssd_exec_t;
+init_daemon_domain(hypervvssd_t, hypervvssd_exec_t)
+
+type hypervvssd_unit_file_t;
+systemd_unit_file(hypervvssd_unit_file_t)
 
 ########################################
 #
-# Local policy
+# hyperv domain local policy
+#
+
+allow hyperv_domain self:capability net_admin;
+allow hyperv_domain self:netlink_socket create_socket_perms;
+
+allow hyperv_domain self:fifo_file rw_fifo_file_perms;
+allow hyperv_domain self:unix_stream_socket create_stream_socket_perms;
+
+corecmd_exec_shell(hyperv_domain)
+corecmd_exec_bin(hyperv_domain)
+
+dev_read_sysfs(hyperv_domain)
+
+########################################
 #
+# hypervkvp local policy
 #
 
-allow hypervkvpd_t self:fifo_file rw_fifo_file_perms;
-allow hypervkvpd_t self:unix_stream_socket create_stream_socket_perms;
+manage_dirs_pattern(hypervkvp_t, hypervkvp_var_lib_t, hypervkvp_var_lib_t)
+manage_files_pattern(hypervkvp_t, hypervkvp_var_lib_t, hypervkvp_var_lib_t)
+files_var_lib_filetrans(hypervkvp_t, hypervkvp_var_lib_t, dir)
+
+files_dontaudit_search_home(hypervkvp_t)
+
+logging_send_syslog_msg(hypervkvp_t)
+
+sysnet_dns_name_resolve(hypervkvp_t)
 
-logging_send_syslog_msg(hypervkvpd_t)
+userdom_dontaudit_search_admin_dir(hypervkvp_t)
+
+optional_policy(`
+    sysnet_exec_ifconfig(hypervkvp_t)
+')
+
+########################################
+#
+# hypervvssd local policy
+#
 
-miscfiles_read_localization(hypervkvpd_t)
+allow hypervvssd_t self:capability sys_admin;
 
-sysnet_dns_name_resolve(hypervkvpd_t)
+logging_send_syslog_msg(hypervvssd_t)
Index: serefpolicy-contrib-20140730/i18n_input.te
===================================================================
--- serefpolicy-contrib-20140730.orig/i18n_input.te
+++ serefpolicy-contrib-20140730/i18n_input.te
@@ -45,7 +45,6 @@ can_exec(i18n_input_t, i18n_input_exec_t
 kernel_read_kernel_sysctls(i18n_input_t)
 kernel_read_system_state(i18n_input_t)
 
-corenet_all_recvfrom_unlabeled(i18n_input_t)
 corenet_all_recvfrom_netlabel(i18n_input_t)
 corenet_tcp_sendrecv_generic_if(i18n_input_t)
 corenet_tcp_sendrecv_generic_node(i18n_input_t)
@@ -68,7 +67,6 @@ fs_getattr_all_fs(i18n_input_t)
 fs_search_auto_mountpoints(i18n_input_t)
 
 files_read_etc_runtime_files(i18n_input_t)
-files_read_usr_files(i18n_input_t)
 
 auth_use_nsswitch(i18n_input_t)
 
@@ -76,20 +74,9 @@ init_stream_connect_script(i18n_input_t)
 
 logging_send_syslog_msg(i18n_input_t)
 
-miscfiles_read_localization(i18n_input_t)
-
 userdom_dontaudit_use_unpriv_user_fds(i18n_input_t)
 userdom_read_user_home_content_files(i18n_input_t)
-
-tunable_policy(`use_nfs_home_dirs',`
-	fs_read_nfs_files(i18n_input_t)
-	fs_read_nfs_symlinks(i18n_input_t)
-')
-
-tunable_policy(`use_samba_home_dirs',`
-	fs_read_cifs_files(i18n_input_t)
-	fs_read_cifs_symlinks(i18n_input_t)
-')
+userdom_home_reader(i18n_input_t)
 
 optional_policy(`
 	canna_stream_connect(i18n_input_t)
Index: serefpolicy-contrib-20140730/icecast.if
===================================================================
--- serefpolicy-contrib-20140730.orig/icecast.if
+++ serefpolicy-contrib-20140730/icecast.if
@@ -176,6 +176,14 @@ interface(`icecast_admin',`
 		type icecast_var_run_t;
 	')
 
+	allow $1 icecast_t:process signal_perms;
+	ps_process_pattern($1, icecast_t)
+
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 icecast_t:process ptrace;
+	')
+
+	# Allow icecast_t to restart the apache service
 	icecast_initrc_domtrans($1)
 	domain_system_change_exemption($1)
 	role_transition $2 icecast_initrc_exec_t system_r;
Index: serefpolicy-contrib-20140730/icecast.te
===================================================================
--- serefpolicy-contrib-20140730.orig/icecast.te
+++ serefpolicy-contrib-20140730/icecast.te
@@ -65,12 +65,8 @@ dev_read_sysfs(icecast_t)
 dev_read_urand(icecast_t)
 dev_read_rand(icecast_t)
 
-domain_use_interactive_fds(icecast_t)
-
 auth_use_nsswitch(icecast_t)
 
-miscfiles_read_localization(icecast_t)
-
 tunable_policy(`icecast_use_any_tcp_ports',`
 	corenet_tcp_connect_all_ports(icecast_t)
 	corenet_sendrecv_all_client_packets(icecast_t)
Index: serefpolicy-contrib-20140730/ifplugd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/ifplugd.if
+++ serefpolicy-contrib-20140730/ifplugd.if
@@ -119,7 +119,7 @@ interface(`ifplugd_admin',`
 		type ifplugd_initrc_exec_t;
 	')
 
-	allow $1 ifplugd_t:process { ptrace signal_perms };
+	allow $1 ifplugd_t:process signal_perms;
 	ps_process_pattern($1, ifplugd_t)
 
 	init_labeled_script_domtrans($1, ifplugd_initrc_exec_t)
Index: serefpolicy-contrib-20140730/ifplugd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/ifplugd.te
+++ serefpolicy-contrib-20140730/ifplugd.te
@@ -10,7 +10,7 @@ type ifplugd_exec_t;
 init_daemon_domain(ifplugd_t, ifplugd_exec_t)
 
 type ifplugd_etc_t;
-files_type(ifplugd_etc_t)
+files_config_file(ifplugd_etc_t)
 
 type ifplugd_initrc_exec_t;
 init_script_file(ifplugd_initrc_exec_t)
@@ -49,14 +49,11 @@ corecmd_exec_shell(ifplugd_t)
 dev_read_sysfs(ifplugd_t)
 
 domain_read_confined_domains_state(ifplugd_t)
-domain_dontaudit_read_all_domains_state(ifplugd_t)
 
 auth_use_nsswitch(ifplugd_t)
 
 logging_send_syslog_msg(ifplugd_t)
 
-miscfiles_read_localization(ifplugd_t)
-
 netutils_domtrans(ifplugd_t)
 
 sysnet_domtrans_ifconfig(ifplugd_t)
Index: serefpolicy-contrib-20140730/imaze.te
===================================================================
--- serefpolicy-contrib-20140730.orig/imaze.te
+++ serefpolicy-contrib-20140730/imaze.te
@@ -45,7 +45,6 @@ kernel_list_proc(imazesrv_t)
 kernel_read_kernel_sysctls(imazesrv_t)
 kernel_read_proc_symlinks(imazesrv_t)
 
-corenet_all_recvfrom_unlabeled(imazesrv_t)
 corenet_all_recvfrom_netlabel(imazesrv_t)
 corenet_tcp_sendrecv_generic_if(imazesrv_t)
 corenet_udp_sendrecv_generic_if(imazesrv_t)
@@ -71,8 +70,6 @@ auth_use_nsswitch(imazesrv_t)
 
 logging_send_syslog_msg(imazesrv_t)
 
-miscfiles_read_localization(imazesrv_t)
-
 userdom_use_unpriv_users_fds(imazesrv_t)
 userdom_dontaudit_search_user_home_dirs(imazesrv_t)
 
Index: serefpolicy-contrib-20140730/inetd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/inetd.if
+++ serefpolicy-contrib-20140730/inetd.if
@@ -37,6 +37,12 @@ interface(`inetd_core_service_domain',`
 
 	domtrans_pattern(inetd_t, $2, $1)
 	allow inetd_t $1:process { siginh sigkill };
+
+    init_domain($1, $2)
+
+	optional_policy(`
+		abrt_stream_connect($1)
+	')
 ')
 
 ########################################
Index: serefpolicy-contrib-20140730/inetd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/inetd.te
+++ serefpolicy-contrib-20140730/inetd.te
@@ -37,9 +37,9 @@ ifdef(`enable_mcs',`
 # Local policy
 #
 
-allow inetd_t self:capability { setuid setgid sys_resource };
+allow inetd_t self:capability { setuid setgid };
 dontaudit inetd_t self:capability sys_tty_config;
-allow inetd_t self:process { setsched setexec setrlimit };
+allow inetd_t self:process { setsched setexec };
 allow inetd_t self:fifo_file rw_fifo_file_perms;
 allow inetd_t self:tcp_socket { accept listen };
 allow inetd_t self:fd use;
@@ -61,6 +61,7 @@ kernel_read_system_state(inetd_t)
 kernel_tcp_recvfrom_unlabeled(inetd_t)
 
 corecmd_bin_domtrans(inetd_t, inetd_child_t)
+corecmd_exec_shell(inetd_t)
 
 corenet_all_recvfrom_unlabeled(inetd_t)
 corenet_all_recvfrom_netlabel(inetd_t)
@@ -98,6 +99,11 @@ corenet_sendrecv_inetd_child_server_pack
 corenet_tcp_bind_inetd_child_port(inetd_t)
 corenet_udp_bind_inetd_child_port(inetd_t)
 
+corenet_tcp_bind_echo_port(inetd_t)
+corenet_udp_bind_echo_port(inetd_t)
+corenet_tcp_bind_time_port(inetd_t)
+corenet_udp_bind_time_port(inetd_t)
+
 corenet_sendrecv_ircd_server_packets(inetd_t)
 corenet_tcp_bind_ircd_port(inetd_t)
 
@@ -157,8 +163,6 @@ auth_use_nsswitch(inetd_t)
 
 logging_send_syslog_msg(inetd_t)
 
-miscfiles_read_localization(inetd_t)
-
 mls_fd_share_all_levels(inetd_t)
 mls_socket_read_to_clearance(inetd_t)
 mls_socket_write_to_clearance(inetd_t)
@@ -188,17 +192,13 @@ optional_policy(`
 ')
 
 optional_policy(`
-	tftp_read_config_files(inetd_t)
+	tftp_read_config(inetd_t)
 ')
 
 optional_policy(`
 	udev_read_db(inetd_t)
 ')
 
-optional_policy(`
-	unconfined_domtrans(inetd_t)
-')
-
 ########################################
 #
 # Child local policy
@@ -220,6 +220,14 @@ kernel_read_kernel_sysctls(inetd_child_t
 kernel_read_network_state(inetd_child_t)
 kernel_read_system_state(inetd_child_t)
 
+corenet_all_recvfrom_netlabel(inetd_child_t)
+corenet_tcp_sendrecv_generic_if(inetd_child_t)
+corenet_udp_sendrecv_generic_if(inetd_child_t)
+corenet_tcp_sendrecv_generic_node(inetd_child_t)
+corenet_udp_sendrecv_generic_node(inetd_child_t)
+corenet_tcp_sendrecv_all_ports(inetd_child_t)
+corenet_udp_sendrecv_all_ports(inetd_child_t)
+
 dev_read_urand(inetd_child_t)
 
 fs_getattr_xattr_fs(inetd_child_t)
@@ -230,7 +238,11 @@ auth_use_nsswitch(inetd_child_t)
 
 logging_send_syslog_msg(inetd_child_t)
 
-miscfiles_read_localization(inetd_child_t)
+sysnet_read_config(inetd_child_t)
+
+optional_policy(`
+	kerberos_use(inetd_child_t)
+')
 
 optional_policy(`
 	unconfined_domain(inetd_child_t)
Index: serefpolicy-contrib-20140730/inn.if
===================================================================
--- serefpolicy-contrib-20140730.orig/inn.if
+++ serefpolicy-contrib-20140730/inn.if
@@ -124,6 +124,7 @@ interface(`inn_read_config',`
 		type innd_etc_t;
 	')
 
+	files_search_etc($1)
 	allow $1 innd_etc_t:dir list_dir_perms;
 	allow $1 innd_etc_t:file read_file_perms;
 	allow $1 innd_etc_t:lnk_file read_lnk_file_perms;
@@ -144,12 +145,31 @@ interface(`inn_read_news_lib',`
 		type innd_var_lib_t;
 	')
 
+	files_search_var_lib($1)
 	allow $1 innd_var_lib_t:dir list_dir_perms;
 	allow $1 innd_var_lib_t:file read_file_perms;
 ')
 
 ########################################
 ## <summary>
+##	Write innd inherited news library content.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`inn_write_inherited_news_lib',`
+	gen_require(`
+		type innd_var_lib_t;
+	')
+
+	allow $1 innd_var_lib_t:file write_inherited_file_perms;
+')
+
+########################################
+## <summary>
 ##	Read innd news spool content.
 ## </summary>
 ## <param name="domain">
@@ -163,6 +183,7 @@ interface(`inn_read_news_spool',`
 		type news_spool_t;
 	')
 
+	files_search_spool($1)
 	allow $1 news_spool_t:dir list_dir_perms;
 	allow $1 news_spool_t:file read_file_perms;
 	allow $1 news_spool_t:lnk_file read_lnk_file_perms;
@@ -226,8 +247,15 @@ interface(`inn_domtrans',`
 interface(`inn_admin',`
 	gen_require(`
 		type innd_t, innd_etc_t, innd_log_t;
-		type news_spool_t, innd_var_lib_t;
-		type innd_var_run_t, innd_initrc_exec_t;
+		type news_spool_t, innd_var_lib_t, innd_var_run_t;
+		type innd_initrc_exec_t;
+	')
+
+	allow $1 innd_t:process signal_perms;
+	ps_process_pattern($1, innd_t)
+
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 innd_t:process ptrace;
 	')
 
 	init_labeled_script_domtrans($1, innd_initrc_exec_t)
Index: serefpolicy-contrib-20140730/inn.te
===================================================================
--- serefpolicy-contrib-20140730.orig/inn.te
+++ serefpolicy-contrib-20140730/inn.te
@@ -26,6 +26,7 @@ files_pid_file(innd_var_run_t)
 
 type news_spool_t;
 files_mountpoint(news_spool_t)
+files_spool_file(news_spool_t)
 
 ########################################
 #
@@ -54,7 +55,7 @@ manage_files_pattern(innd_t, innd_var_li
 manage_dirs_pattern(innd_t, innd_var_run_t, innd_var_run_t)
 manage_files_pattern(innd_t, innd_var_run_t, innd_var_run_t)
 manage_sock_files_pattern(innd_t, innd_var_run_t, innd_var_run_t)
-files_pid_filetrans(innd_t, innd_var_run_t, file)
+files_pid_filetrans(innd_t, innd_var_run_t, { dir file })
 
 manage_dirs_pattern(innd_t, news_spool_t, news_spool_t)
 manage_files_pattern(innd_t, news_spool_t, news_spool_t)
@@ -65,7 +66,6 @@ can_exec(innd_t, innd_exec_t)
 kernel_read_kernel_sysctls(innd_t)
 kernel_read_system_state(innd_t)
 
-corenet_all_recvfrom_unlabeled(innd_t)
 corenet_all_recvfrom_netlabel(innd_t)
 corenet_tcp_sendrecv_generic_if(innd_t)
 corenet_tcp_sendrecv_generic_node(innd_t)
@@ -91,18 +91,16 @@ fs_search_auto_mountpoints(innd_t)
 
 files_list_spool(innd_t)
 files_read_etc_runtime_files(innd_t)
-files_read_usr_files(innd_t)
 
 auth_use_nsswitch(innd_t)
 
 logging_send_syslog_msg(innd_t)
 
-miscfiles_read_localization(innd_t)
-
 seutil_dontaudit_search_config(innd_t)
 
 userdom_dontaudit_use_unpriv_user_fds(innd_t)
 userdom_dontaudit_search_user_home_dirs(innd_t)
+userdom_dgram_send(innd_t)
 
 mta_send_mail(innd_t)
 
Index: serefpolicy-contrib-20140730/iodine.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/iodine.fc
+++ serefpolicy-contrib-20140730/iodine.fc
@@ -1,3 +1,5 @@
 /etc/rc\.d/init\.d/((iodined)|(iodine-server))	--	gen_context(system_u:object_r:iodined_initrc_exec_t,s0)
 
+/usr/lib/systemd/system/iodine-server.*     --  gen_context(system_u:object_r:iodined_unit_file_t,s0)
+
 /usr/sbin/iodined	--	gen_context(system_u:object_r:iodined_exec_t,s0)
Index: serefpolicy-contrib-20140730/iodine.if
===================================================================
--- serefpolicy-contrib-20140730.orig/iodine.if
+++ serefpolicy-contrib-20140730/iodine.if
@@ -2,6 +2,49 @@
 
 ########################################
 ## <summary>
+##	Execute NetworkManager with a domain transition.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`iodined_domtrans',`
+	gen_require(`
+		type iodined_t, iodined_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, iodined_exec_t, iodined_t)
+')
+
+########################################
+## <summary>
+##  Execute iodined server in the iodined domain.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
+## </param>
+#
+interface(`iodined_systemctl',`
+    gen_require(`
+        type iodined_t;
+        type iodined_unit_file_t;
+    ')
+
+        systemd_exec_systemctl($1)
+        systemd_read_fifo_file_passwd_run($1)
+        allow $1 iodined_unit_file_t:file read_file_perms;
+        allow $1 iodined_unit_file_t:service manage_service_perms;
+
+        ps_process_pattern($1, iodined_t)
+')
+
+########################################
+## <summary>
 ##	All of the rules required to
 ##	administrate an iodined environment
 ## </summary>
Index: serefpolicy-contrib-20140730/iodine.te
===================================================================
--- serefpolicy-contrib-20140730.orig/iodine.te
+++ serefpolicy-contrib-20140730/iodine.te
@@ -12,6 +12,9 @@ init_daemon_domain(iodined_t, iodined_ex
 type iodined_initrc_exec_t;
 init_script_file(iodined_initrc_exec_t)
 
+type iodined_unit_file_t;
+systemd_unit_file(iodined_unit_file_t)
+
 ########################################
 #
 # Local policy
@@ -43,7 +46,7 @@ corenet_udp_sendrecv_dns_port(iodined_t)
 
 corecmd_exec_shell(iodined_t)
 
-files_read_etc_files(iodined_t)
+auth_use_nsswitch(iodined_t)
 
 logging_send_syslog_msg(iodined_t)
 
Index: serefpolicy-contrib-20140730/iotop.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/iotop.fc
@@ -0,0 +1 @@
+/usr/sbin/iotop		--	gen_context(system_u:object_r:iotop_exec_t,s0)
Index: serefpolicy-contrib-20140730/iotop.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/iotop.if
@@ -0,0 +1,46 @@
+## <summary>Simple top-like I/O monitor</summary>
+
+########################################
+## <summary>
+##	Allow execution of iotop in the iotop domain from the target domain.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition to iotop.
+## </summary>
+## </param>
+#
+interface(`iotop_domtrans',`
+	gen_require(`
+		type iotop_t, iotop_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, iotop_exec_t, iotop_t)
+')
+
+########################################
+## <summary>
+##	Execute iotop in the iotop domain, and
+##	allow the specified role to access the iotop domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition
+##	</summary>
+## </param>
+## <param name="role">
+##	<summary>
+##	The role to be allowed into the iotop domain.
+##	</summary>
+## </param>
+#
+interface(`iotop_run',`
+	gen_require(`
+		type iotop_t;
+		attribute_role iotop_roles;
+	')
+
+	iotop_domtrans($1)
+	roleattribute $2 iotop_roles;
+')
Index: serefpolicy-contrib-20140730/iotop.te
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/iotop.te
@@ -0,0 +1,37 @@
+policy_module(iotop, 1.0.0)
+
+########################################
+#
+# Declarations
+#
+attribute_role iotop_roles;
+roleattribute system_r iotop_roles;
+
+type iotop_t;
+type iotop_exec_t;
+application_domain(iotop_t, iotop_exec_t)
+
+role iotop_roles types iotop_t;
+
+########################################
+#
+# iotop local policy
+#
+
+allow iotop_t self:capability net_admin;
+allow iotop_t self:netlink_route_socket r_netlink_socket_perms;
+
+kernel_read_system_state(iotop_t)
+
+auth_use_nsswitch(iotop_t)
+
+dev_read_urand(iotop_t)
+
+domain_getsched_all_domains(iotop_t)
+domain_read_all_domains_state(iotop_t)
+
+corecmd_exec_bin(iotop_t)
+
+miscfiles_read_localization(iotop_t)
+
+userdom_use_user_terminals(iotop_t)
Index: serefpolicy-contrib-20140730/ipa.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/ipa.fc
@@ -0,0 +1,6 @@
+/usr/lib/systemd/system/ipa-otpd.*		--	gen_context(system_u:object_r:ipa_otpd_unit_file_t,s0)
+
+/usr/libexec/ipa-otpd		--	gen_context(system_u:object_r:ipa_otpd_exec_t,s0)
+
+/var/lib/ipa(/.*)?              gen_context(system_u:object_r:ipa_var_lib_t,s0)
+
Index: serefpolicy-contrib-20140730/ipa.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/ipa.if
@@ -0,0 +1,94 @@
+## <summary>Policy for IPA services.</summary>
+
+########################################
+## <summary>
+##	Execute rtas_errd in the rtas_errd domin.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`ipa_domtrans_otpd',`
+	gen_require(`
+		type ipa_otpd_t, ipa_otpd_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, ipa_otpd_exec_t, ipa_otpd_t)
+')
+
+########################################
+## <summary>
+##	Connect to ipa-otpd over a unix stream socket.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`ipa_stream_connect_otpd',`
+	gen_require(`
+		type ipa_otpd_t;
+	')
+    allow $1 ipa_otpd_t:unix_stream_socket connectto;
+')
+
+########################################
+## <summary>
+##	Allow domain to manage ipa lib files/dirs.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`ipa_search_lib',`
+	gen_require(`
+		type ipa_var_lib_t;
+	')
+
+    search_dirs_pattern($1, ipa_var_lib_t, ipa_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Allow domain to manage ipa lib files/dirs.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`ipa_manage_lib',`
+	gen_require(`
+		type ipa_var_lib_t;
+	')
+
+    manage_files_pattern($1, ipa_var_lib_t, ipa_var_lib_t)
+    manage_dirs_pattern($1, ipa_var_lib_t, ipa_var_lib_t)
+')
+
+########################################
+## <summary>
+##	Allow domain to manage ipa lib files/dirs.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed access.
+##	</summary>
+## </param>
+#
+interface(`ipa_read_lib',`
+	gen_require(`
+		type ipa_var_lib_t;
+	')
+
+    read_files_pattern($1, ipa_var_lib_t, ipa_var_lib_t)
+    list_dirs_pattern($1, ipa_var_lib_t, ipa_var_lib_t)
+')
+
Index: serefpolicy-contrib-20140730/ipa.te
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/ipa.te
@@ -0,0 +1,43 @@
+policy_module(ipa, 1.0.0)
+
+########################################
+#
+# Declarations
+#
+
+attribute ipa_domain;
+
+type ipa_otpd_t, ipa_domain;
+type ipa_otpd_exec_t;
+init_daemon_domain(ipa_otpd_t, ipa_otpd_exec_t)
+
+type ipa_otpd_unit_file_t;
+systemd_unit_file(ipa_otpd_unit_file_t)
+
+type ipa_var_lib_t;
+files_type(ipa_var_lib_t)
+
+########################################
+#
+# ipa_otpd local policy
+#
+
+allow ipa_otpd_t self:capability2 block_suspend;
+
+allow ipa_otpd_t self:fifo_file rw_fifo_file_perms;
+allow ipa_otpd_t self:unix_stream_socket create_stream_socket_perms;
+
+corenet_tcp_connect_radius_port(ipa_otpd_t)
+
+dev_read_urand(ipa_otpd_t)
+dev_read_rand(ipa_otpd_t)
+
+sysnet_dns_name_resolve(ipa_otpd_t)
+
+optional_policy(`
+    dirsrv_stream_connect(ipa_otpd_t)
+')
+
+optional_policy(`
+	kerberos_use(ipa_otpd_t)
+')
Index: serefpolicy-contrib-20140730/ircd.if
===================================================================
--- serefpolicy-contrib-20140730.orig/ircd.if
+++ serefpolicy-contrib-20140730/ircd.if
@@ -33,8 +33,8 @@ interface(`ircd_admin',`
 
 	files_search_etc($1)
 	admin_pattern($1, ircd_etc_t)
-
-	logging_search_log($1)
+ 
+	logging_search_logs($1)
 	admin_pattern($1, ircd_log_t)
 
 	files_search_var_lib($1)
Index: serefpolicy-contrib-20140730/ircd.te
===================================================================
--- serefpolicy-contrib-20140730.orig/ircd.te
+++ serefpolicy-contrib-20140730/ircd.te
@@ -52,7 +52,6 @@ kernel_read_kernel_sysctls(ircd_t)
 
 corecmd_exec_bin(ircd_t)
 
-corenet_all_recvfrom_unlabeled(ircd_t)
 corenet_all_recvfrom_netlabel(ircd_t)
 corenet_tcp_sendrecv_generic_if(ircd_t)
 corenet_tcp_sendrecv_generic_node(ircd_t)
@@ -75,8 +74,6 @@ auth_use_nsswitch(ircd_t)
 
 logging_send_syslog_msg(ircd_t)
 
-miscfiles_read_localization(ircd_t)
-
 userdom_dontaudit_use_unpriv_user_fds(ircd_t)
 userdom_dontaudit_search_user_home_dirs(ircd_t)
 
Index: serefpolicy-contrib-20140730/irc.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/irc.fc
+++ serefpolicy-contrib-20140730/irc.fc
@@ -1,6 +1,6 @@
 HOME_DIR/\.ircmotd	--	gen_context(system_u:object_r:irc_home_t,s0)
 HOME_DIR/\.irssi(/.*)?	gen_context(system_u:object_r:irc_home_t,s0)
-HOME_DIR/irclogs(/.*)?	gen_context(system_u:object_r:irc_log_home_t,s0)
+HOME_DIR/irclog(/.*)?	gen_context(system_u:object_r:irc_home_t,s0)
 
 /etc/irssi\.conf	--	gen_context(system_u:object_r:irc_conf_t,s0)
 
Index: serefpolicy-contrib-20140730/irc.if
===================================================================
--- serefpolicy-contrib-20140730.orig/irc.if
+++ serefpolicy-contrib-20140730/irc.if
@@ -20,6 +20,7 @@ interface(`irc_role',`
 		attribute_role irc_roles;
 		type irc_t, irc_exec_t, irc_home_t;
 		type irc_tmp_t, irc_log_home_t;
+		type irssi_t, irssi_exec_t, irssi_home_t;
 	')
 
 	########################################
@@ -37,12 +38,42 @@ interface(`irc_role',`
 	domtrans_pattern($2, irc_exec_t, irc_t)
 
 	ps_process_pattern($2, irc_t)
-	allow $2 irc_t:process { ptrace signal_perms };
+	allow $2 irc_t:process signal_perms;
+	tunable_policy(`deny_ptrace',`',`
+		allow $2 irc_t:process ptrace;
+	')
+
+	domtrans_pattern($2, irssi_exec_t, irssi_t)
+
+	allow $2 irssi_t:process signal_perms;
+	ps_process_pattern($2, irssi_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $2 irssi_t:process ptrace;
+	')
+
+	allow $2 { irc_home_t irc_log_home_t irc_tmp_t irssi_home_t }:dir { manage_dir_perms relabel_dir_perms };
+	allow $2 { irc_home_t irc_log_home_t irc_tmp_t irssi_home_t }:file { manage_file_perms relabel_file_perms };
+	allow $2 { irc_home_t irc_log_home_t irc_tmp_t irssi_home_t }:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
+
+	irc_filetrans_home_content($2)
+')
 
-	allow $2 { irc_home_t irc_log_home_t irc_tmp_t }:dir { manage_dir_perms relabel_dir_perms };
-	allow $2 { irc_home_t irc_log_home_t irc_tmp_t }:file { manage_file_perms relabel_file_perms };
-	allow $2 { irc_home_t irc_log_home_t irc_tmp_t }:lnk_file { manage_lnk_file_perms relabel_lnk_file_perms };
-	userdom_user_home_dir_filetrans($2, irc_home_t, dir, ".irssi")
-	userdom_user_home_dir_filetrans($2, irc_home_t, file, ".ircmotd")
-	userdom_user_home_dir_filetrans($2, irc_log_home_t, dir, "irclogs")
+#######################################
+## <summary>
+##      Transition to alsa named content
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`irc_filetrans_home_content',`
+		gen_require(`
+			type irc_home_t;
+			type irssi_home_t;
+		')
+		userdom_user_home_dir_filetrans($1, irc_home_t, file, ".ircmotd")
+		userdom_user_home_dir_filetrans($1, irc_home_t, dir, ".irssi")
+		userdom_user_home_dir_filetrans($1, irssi_home_t, dir, "irclogs")
 ')
